'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _bluebird = require('bluebird');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

process.on('unhandledRejection', function (e) {
  throw e;
});

// TODO
// - Use init-package-json.
// - Use promises.

var main = (function () {
  var ref = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee4() {
    var fs, path, cwd, modifyPackageJson, replaceFile, _require, spawnSync, init, _, inquirer, _require2, promisify, Promise, gulpfileContents, confirm, installDependencies, installBabelDevDependencies, installBabelRuntimeDependencies;

    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:

            //region Imports
            fs = require('fs');
            path = require('path');
            cwd = require('cwd');
            modifyPackageJson = require('./util/modifyPackageJson');
            replaceFile = require('./util/replaceFile');
            _require = require('child_process');
            spawnSync = _require.spawnSync;
            init = require('init-package-json');
            _ = require('lodash');
            inquirer = require('inquirer');
            _require2 = require('bluebird');
            promisify = _require2.promisify;
            Promise = require('bluebird');
            //endregion

            // npm init

            if (!fs.existsSync(cwd('package.json'))) {
              console.log('Initializing npm package...');
              spawnSync('npm init -f');
              //init(cwd(), 'package.json', {}, (e, data) => {
              //})
            }

            // gulp

            console.log('Adding gulp to package.json');

            _context4.next = 17;
            return promisify(modifyPackageJson)(function (json) {
              _.set(json, 'scripts.gulp', './node_modules/gulp/bin/gulp.js');
              return json;
            });

          case 17:

            // gulpfile.js

            console.log('Updating gulpfile...');

            gulpfileContents = "var gulp = require('gulp')\n" + "require('babelator')(gulp)\n";
            _context4.next = 21;
            return promisify(replaceFile)(cwd('gulpfile.js'), gulpfileContents);

          case 21:

            // Add babelator dependency

            console.log('Adding babelator dependency...');

            confirm = function confirm(message) {
              return new Promise(function (resolve, reject) {
                inquirer.prompt([{ type: 'confirm', name: 'confirm', message: message }], function (answers) {
                  resolve(answers);
                });
              });
            };

            installDependencies = (function () {
              var ref = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee() {
                var answers;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:

                        // TODO(vjpr): Provide options instead of 2 confirms. Duh!
                        answers = null;
                        _context.next = 3;
                        return confirm('Run `npm i -D babelator gulpjs/gulp.git#4.0`?');

                      case 3:
                        answers = _context.sent;

                        if (!answers.confirm) {
                          _context.next = 7;
                          break;
                        }

                        spawnSync('npm', ['i', '-D', 'babelator', 'gulpjs/gulp.git#4.0'], { stdio: 'inherit' });
                        return _context.abrupt('return');

                      case 7:
                        _context.next = 9;
                        return confirm('Run `npm link -D babelator gulp`?');

                      case 9:
                        answers = _context.sent;

                        if (!answers.confirm) {
                          _context.next = 13;
                          break;
                        }

                        spawnSync('npm', ['link', 'babelator', 'gulp'], { stdio: 'inherit' });
                        return _context.abrupt('return');

                      case 13:

                        // Instructions
                        console.log('Please run `npm install`');
                        console.log('Tip: Use `npm_lazy` module to locally cache npm modules.');

                      case 15:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, this);
              }));
              return function installDependencies() {
                return ref.apply(this, arguments);
              };
            })();

            // TODO(vjpr): We should remove react from here and make it optional in another bootstrap task.
            // But it is currently used somewhere in babelator.

            installBabelDevDependencies = (function () {
              var ref = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee2() {
                var answers;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        answers = null;
                        _context2.next = 3;
                        return confirm('Run `npm link -D babel-preset-es2015 babel-preset-stage-0 babel-preset-react`?');

                      case 3:
                        answers = _context2.sent;

                        if (!answers.confirm) {
                          _context2.next = 7;
                          break;
                        }

                        spawnSync('npm', ['link', 'babel-preset-es2015', 'babel-preset-stage-0', 'babel-preset-react'], { stdio: 'inherit' });
                        return _context2.abrupt('return');

                      case 7:
                        _context2.next = 9;
                        return confirm('Run `npm i -D babel-preset-es2015 babel-preset-stage-0 babel-preset-react');

                      case 9:
                        answers = _context2.sent;

                        if (!answers.confirm) {
                          _context2.next = 13;
                          break;
                        }

                        spawnSync('npm', ['i', 'babel-preset-es2015', 'babel-preset-stage-0', 'babel-preset-react'], { stdio: 'inherit' });
                        return _context2.abrupt('return');

                      case 13:
                      case 'end':
                        return _context2.stop();
                    }
                  }
                }, _callee2, this);
              }));
              return function installBabelDevDependencies() {
                return ref.apply(this, arguments);
              };
            })();

            installBabelRuntimeDependencies = (function () {
              var ref = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee3() {
                var deps, answers;
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:

                        // For regenerator when using async.
                        deps = 'babel-runtime bluebird';
                        answers = null;
                        _context3.next = 4;
                        return confirm('Run `npm link -S ' + deps + '`?');

                      case 4:
                        answers = _context3.sent;

                        if (!answers.confirm) {
                          _context3.next = 8;
                          break;
                        }

                        spawnSync('npm', ['link', 'babel-runtime', 'bluebird'], { stdio: 'inherit' });
                        return _context3.abrupt('return');

                      case 8:
                        _context3.next = 10;
                        return confirm('Run `npm i -S ' + deps + '`?');

                      case 10:
                        answers = _context3.sent;

                        if (!answers.confirm) {
                          _context3.next = 14;
                          break;
                        }

                        spawnSync('npm', ['i', 'babel-runtime@^5', 'bluebird'], { stdio: 'inherit' });
                        return _context3.abrupt('return');

                      case 14:
                      case 'end':
                        return _context3.stop();
                    }
                  }
                }, _callee3, this);
              }));
              return function installBabelRuntimeDependencies() {
                return ref.apply(this, arguments);
              };
            })();

            _context4.next = 28;
            return installDependencies();

          case 28:
            _context4.next = 30;
            return installBabelDevDependencies();

          case 30:
            _context4.next = 32;
            return installBabelRuntimeDependencies();

          case 32:

            console.log('Done!');

          case 33:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));
  return function main() {
    return ref.apply(this, arguments);
  };
})();

function cli() {
  main().then(function () {});
}

module.exports = cli;